﻿namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.tapGestureRecognizer.Tapped += tapGestureRecognizer_Tapped;

        this.rectangleFrame.IsVisible = false;
        this.circleFrame2.IsVisible   = false;

        StartAnimationAsync();
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region 탭 제스처 인식기 탭 처리하기 - tapGestureRecognizer_Tapped(sender, e)

    /// <summary>
    /// 탭 제스처 인식기 탭 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private async void tapGestureRecognizer_Tapped(object sender, EventArgs e)
    {
        await Task.WhenAll
        (
            this.rectangleFrame.FadeTo(0, 300, Easing.SinOut),
            this.circleFrame2.FadeTo(0, 300, Easing.SinOut)
        );

        await Task.WhenAll
        (
            this.circleFrame1.FadeTo(0, 1000, Easing.SinIn),
            this.circleFrame1.ScaleTo(10, 1000, Easing.SinOut)
        );

        await Navigation.PushAsync(new MainPage());
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region 애니메이션 시작하기 (비동기) - StartAnimationAsync()

    /// <summary>
    /// 애니메이션 시작하기 (비동기)
    /// </summary>
    private async void StartAnimationAsync()
    {
        await Task.WhenAll
        (
            this.circleFrame1.ScaleTo(10, 0),
            this.circleFrame1.FadeTo(0, 0)
        );

        await Task.WhenAll
        (
            this.circleFrame1.ScaleTo(1, 1000, Easing.SinIn),
            this.circleFrame1.FadeTo(0.7, 1000, Easing.SinOut)
        );

        this.rectangleFrame.IsVisible = true;
        this.circleFrame2.IsVisible   = true;

        await Task.WhenAll
        (
            this.rectangleFrame.FadeTo(0.7, 300, Easing.SinIn),
            this.circleFrame2.FadeTo(0.7, 300, Easing.SinIn)
        );
    }

    #endregion
}